﻿local ADDONNAME, MHProfessionData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
MHProfessionData.Functions = {}
local F = MHProfessionData.Functions;
local _;
--[SVARS]Saved Variables, Per Character
local defaults  = {
	MODE 				= 0, 		-- 0:Short 		1:Long
	LOCK 				= false,		-- F:unlocked	T:locked
	VISIBLE 			= true,		-- 0:not vis	1:vis
	LINK 				= 1,		-- 0:plain		1:show links
	EXPAND_DIRECTION 	= -1,		-- 1:up		   -1:down
	FIRSTRUN 			= true,		-- if this is first run
	CONFIGMODE 			= false,	-- in Config Mode?
	SCALE = {						-- Archive the Frame Scale
			current 	= 1.00, 	-- current scale
			min 		= 0.50,		-- min scale
			max 		= 4.00		-- max scale
	},
	LOCUS = {						-- Archive the Frame Location
			rp 			= "CENTER",	-- relativePoint
			x 			= 0,		-- xOffset
			y 			= 0			-- yOffset
	},
	TRACKING = {					-- Default all On
			[1] 		= true,
			[2] 		= true,
			[3] 		= true,
			[4] 		= true,
			[5] 		= true,
	},
	TIER = {						-- Crafting Tier: Default -1
			[1] 		= -1,		-- -1: Needs to be set, detect highest
			[2] 		= -1,		-- 0: Not learned/ Not tracked
			[3] 		= -1,		-- 1 -> 9: Tier based on expansion 
			[4] 		= -1,
			[5] 		= -1,
	},
	
	
}
local SVPC = {}
-- Local Variables
-- Text Color Constants
local White  				= "|cffffffff";
local Red    				= "|cffff0000";
local Green  				= "|cff00ff00";
local Blue   				= "|cff6060ff";
local Cyan   				= "|cff00ffff";
local Magenta				= "|cffff00ff";
local Yellow 				= "|cffffff00";
-- Bar State Colors
-- local SKILLMAXNEARCOLOR		= {r = 1.00, g = 0.00, b = 0.00};
-- local SKILLNORMALCOLOR		= {r = 0.25, g = 0.25, b = 0.75};
-- local SKILLCAPCOLOR 		= {r = 0.25, g = 0.65, b = 0.25};
-- -- 
-- local VariablesLoaded 		= false;
-- local LinkTemplate 			= "\124cffffd000\124Henchant:SPELL\124h[SKILL: NAME]\124h\124r"
--local FrameUI = { UIObject = {}, };
local UIObject = {};		--Quick access to Skill Entry Frames
local debugMode = false;	
-- SkillLineIDs
local SLI = {
	-- 		 WoW	BC		Wrath	Cata	MOP		WOD		Legion	BFA		SL
	[164] = {2477,	2476,	2475,	2474,	2473,	2472,	2454,	2437,	2751},
	[165] = {2532,	2531,	2530,	2529,	2528,	2527,	2526,	2525,	2758,},
	[171] = {2485,	2484,	2483,	2482,	2481,	2480,	2479,	2478,	2750,},
	[182] = {2556,	2555,	2554,	2553,	2552,	2551,	2550,	2549,	2760,},
	[185] = {2548,	2547,	2546,	2545,	2544,	2543,	2542,	2541,	2752,},
	[186] = {2572,	2571,	2570,	2569,	2568,	2567,	2566,	2565,	2761,},
	[197] = {2540,	2539,	2538,	2537,	2536,	2535,	2534,	2533,	2759,},
	[202] = {2506,	2505,	2504,	2503,	2502,	2501,	2500,	2499,	2755,},
	[333] = {2594,	2493,	2492,	2491,	2489,	2488,	2487,	2486,	2753,},
	[356] = {2592,	2591,	2590,	2589,	2588,	2587,	2586,	2585,	2754,},
	[393] = {2564,	2563,	2562,	2561,	2560,	2559,	2558,	2557,	2762,},
	[755] = {2524,	2523,	2522,	2521,	2520,	2519,	2518,	2517,	2757,},
	[773] = {2514,	2513,	2512,	2511,	2510,	2509,	2508,	2507,	2756,},
};
local SLIByName = {
	["Blacksmithing"] = SLI[164],
	["Leatherworking"] = SLI[165],
	["Alchemy"] = SLI[171],
	["Herbalism"] = SLI[182],
	["Cooking"] = SLI[185],
	["Mining"] = SLI[186],
	["Tailoring"] = SLI[197],
	["Engineering"] = SLI[202],
	["Enchanting"] = SLI[333],
	["Fishing"] = SLI[356],
	["Skinning"] = SLI[393],
	["Jewelcrafting"] = SLI[755],
	["Inscription"] = SLI[773],
};
-- Expansion Names and Icons
local XPACS = {
	List = {
		"Classic",
		"Outland",
		"Northrend",
		"Cataclysm",
		"Pandaria",
		"Draenor",
		"Legion",
		"Zand/KT",
		"Shadowlands",
	},
	Icon = {
		1120721,
		135804,
		630787,
		574788,
		572034,
		143856,
		1417744,
		3012068,
		3726261,
	},
}
local initialized = false;
--local SKILLCAPMSG 			= "Skill At Max Level";
--local SKILLMAXMSG 			= "Seek Training";
-- Current Skill Cap
--local SKILLCAP 				= (GetAccountExpansionLevel() * 75) + 300;
-- Localize archive data
-- local CollectionTerm		= PHUDdata.CollectionTerm;
-- local Profession			= PHUDdata.Profession;
-- local ProfessionNameSlot	= PHUDdata.ProfessionNameSlot;
--local BarTexturePath		= PHUDdata.BarTexturePath;
--local BarTextures			= PHUDdata.BarTextures;
-- local SkillTier				= PHUDdata.SkillTier;

-- local SkillName 			= PHUDdata.SkillName;
-- Slash Commands
SLASH_MiniHudProfession1, SLASH_MiniHudProfession2 = '/mhp', '/mhprof';	-- /Commands
---------------------------------------------------------------------------------------------------------------------------------
--	To Do
---------------------------------------------------------------------------------------------------------------------------------
-- save variables



--[[INITIALIZERS]]--
--[LOADA] Loading Action
function F.OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");				-- AddOn Loaded
	self:RegisterEvent("PLAYER_ENTERING_WORLD");	-- Player Information Loaded
	
	--self:RegisterEvent("CHAT_MSG_TRADESKILLS");
	self:RegisterEvent("CHAT_MSG_SKILL");			
	--self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	--self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT");		-- Player Exits Combat (Addon actions no longer restricted)
	--self:RegisterEvent("NEW_RECIPE_LEARNED");
	--self:RegisterEvent("TRADE_SKILL_LIST_UPDATE");	
	self:RegisterEvent("SKILL_LINES_CHANGED");		--Learn/Unlearn an ability
	--self:RegisterEvent("SPELLS_CHANGED");
end
--[EVENT] Event Handler
function F.OnEvent(self, event, ...)
	if debugMode then print("MHP: OnEvent: "..event) end
	
	-- Starts the addon
	if (event == "ADDON_LOADED") then
		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage(Green..ADDONNAME.." "..Red..VERSION..Green..": Loaded.");
			MiniHudProfessionSVPC = MiniHudProfessionSVPC or CopyTable(defaults) -- load our defaults if we have no SVPC yet (first run)
			SVPC = MiniHudProfessionSVPC;
			
			
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		--XPACS.dropDown:SetItem(XPACS.Choice);
		local locked = SVPC.LOCK
		SVPC.LOCK = false
		F.Initialize()
		SVPC.LOCK = locked;
		F.Update();
	elseif (event == "SKILL_LINES_CHANGED") then
		F.Toggle(false)
	elseif event == "CHAT_MSG_SKILL" then
		local msg,_ = ...
		msg = string.sub(msg, 21, string.len(msg) - 7)
		-- Update tracking for new skills
		local a,b,c,d,e = GetProfessions()		
		local profs = {a,b,c,d,e}
		for i = 1, 5 do
			if profs[i] ~= nil then
				local name,_,_,_,_,_,_,_,_,_,specName = GetProfessionInfo(profs[i])
				if name == msg or specName == msg then 
					-- If already tracking Skill 1 and the new skill replaces skill 1 then...
					if SVPC.TRACKING[i] and (i == 1) and name==msg then 
						UIObject[2].CheckButton:SetChecked(true);
						SVPC.TRACKING[2] = true
					end
					UIObject[i].CheckButton:SetChecked(true);
					SVPC.TRACKING[i] = true
				end
			end
		end
	end
end

function F.SetBackdropData(frame)
	frame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileEdge = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 },
	})
	frame:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)
	frame:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b)
	
end
--[NMTAG] Addon Name Tag Encapsulator
function F.Tag(msg)
	if msg == nil then return end;
	return (Green.."MH:Profession: "..Cyan..msg.."|r");
end
--[INITF] Initialize Frames
function F.Initialize()
	if debugMode then print("MHP: Initialize") end
	if initialized then return end
	initialized = true;
	F.SetBackdropData(MHProfession)
	F.SetBackdropData(XPAC)
	
	for i = 1,5 do
		UIObject[i] = CreateFrame("Frame", "SkillFrame"..i, MHProfession.Frame, "SkillTemplate");
		if i ~= 1 then
			UIObject[i]:SetPoint("TOP", UIObject[i-1], "BOTTOM", 0,7);
		end	
		UIObject[i]:SetID(i);
		UIObject[i].CheckButton:SetChecked(SVPC.TRACKING[i]);
		UIObject[i]:SetAlpha((SVPC.TRACKING[i] and 1) or 0.25);
		if i <= 2 then
		local ddFrame = CreateFrame("FRAME", "DropDown"..i, XPAC.Frame, "UIDropDownMenuTemplate")
		ddFrame:SetPoint("TOPLEFT",UIObject[i], "TOPRIGHT", -13, 0)--30*(i-1))
		UIDropDownMenu_SetWidth(ddFrame, 141)
		function ddFrame.SetValue(self, arg1, arg2, checked)
			MiniHudProfessionSVPC = SVPC
			UIDropDownMenu_SetText(ddFrame, XPACS.List[arg1])
			local idx = tonumber(string.right(self:GetParent().dropdown:GetName(),1))
			--print("Index: "..idx..", Arg1: "..tostring(arg1))
			UIObject[idx].shownID = SLI[({GetProfessionInfo(({GetProfessions()})[idx])})[7]][arg1]
			--print(C_TradeSkillUI.GetTradeSkillLineInfoByID(UIObject[idx].shownID))
			local _,_,maxLv = C_TradeSkillUI.GetTradeSkillLineInfoByID(UIObject[idx].shownID)
			if maxLv ~= 0 then 
				SVPC.TIER[i] = arg1
				MiniHudProfessionSVPC = SVPC
				UIDropDownMenu_SetText(ddFrame, XPACS.List[arg1])
				F.Update()
			else 
				print(F.Tag(XPACS.List[arg1].." Skill Tier not known."))
				UIDropDownMenu_SetText(ddFrame, XPACS.List[SVPC.TIER[i]])
			end
			--print(UIObject[1].DropDown.Text:GetText())
			
			--print("Arg2: "..tostring(arg2))
			--print("Checked: "..tostring(checked))
			--self:GetParent():SetText(arg1)
		end
		
		function ddFrame:SetItem(item)
			if item < 0 or item > #XPACS.List then return end;
			ToggleDropDownMenu(1,nil,self)
			UIDropDownMenu_SetSelectedName(self, XPACS.List[item], true)
			ToggleDropDownMenu(1,nil,self)
		end
		-- Create and bind the initialization function to the dropdown menu
		UIDropDownMenu_Initialize(
			ddFrame, 
			function(self, level, menuList)
				local info = UIDropDownMenu_CreateInfo()
				for i = 1, 9 do
					info.text, info.checked, info.arg1, info.func = XPACS.List[i], i==XPACS.Choice,i, self.SetValue
					--info.icon = XPACS.Icon[i];
					--info.text, info.checked, info.arg1 = XPACNames[i], i==XPACChoice,i
					UIDropDownMenu_AddButton(info)
				end	
				if SVPC.TIER[i] > 0 then 
					UIDropDownMenu_SetSelectedName(self, XPACS.List[SVPC.TIER[i]], true)
				end
			end,"MENU"
		)
		UIDropDownMenu_JustifyText(ddFrame, "LEFT") 
		UIObject[i].DropDown = ddFrame;
		end
	end
		-- XPAC DropDowns
		---------------------------------------------------------------------------------------------------------------------------------
		-- Create the dropDown, and configure its appearance
	if false then
		XPACS.dropDown = CreateFrame("FRAME", "WPDemoDropDown", XPAC.Frame, "UIDropDownMenuTemplate")
		XPACS.dropDown:SetPoint("TOPLEFT", -15, 0)
		UIDropDownMenu_SetWidth(XPACS.dropDown, 95)
		function XPACS.dropDown.SetValue(self, arg1, arg2, checked)
			XPACS.Choice = arg1
			UIDropDownMenu_SetText(XPACS.dropDown, XPACS.List[arg1])
		
			print("Self: "..self:GetName())
			print("Arg1: "..tostring(arg1))
			print("Arg2: "..tostring(arg2))
			print("Checked: "..tostring(checked))
			--self:GetParent():SetText(arg1)
		end
		
		function XPACS.dropDown:SetItem(item)
			if item < 0 or item > #XPACS.List then return end;
			ToggleDropDownMenu(1,nil,self)
			UIDropDownMenu_SetSelectedName(self, XPACS.List[item], true)
			ToggleDropDownMenu(1,nil,self)
		end
		-- Create and bind the initialization function to the dropdown menu
		UIDropDownMenu_Initialize(
			XPACS.dropDown, 
			function(self, level, menuList)
				local info = UIDropDownMenu_CreateInfo()
				for i = 1, 9 do
					info.text, info.checked, info.arg1, info.func = XPACS.List[i], i==XPACS.Choice,i, self.SetValue
					--info.text, info.checked, info.arg1 = XPACNames[i], i==XPACChoice,i
					UIDropDownMenu_AddButton(info)
				end	
				UIDropDownMenu_SetSelectedName(self, XPACS.List[XPACS.Choice], true)
		
			end,"MENU"
		)
		UIDropDownMenu_JustifyText(XPACS.dropDown, "LEFT") 
		--Set initial Values
	end
		
		---------------------------------------------------------------------------------------------------------------------------------
	
	F.Toggle(false)
end

--[UPDAT] Update
function F.Update()
	if debugMode then print("MHP: Update") end;
	local profTabs = {GetProfessions()}
	--print(GetProfessions());
	for i = 1,5 do
		if UIObject[i] ~= nil then
			if profTabs[i] ~= nil  then 
				local name,_,offset,numEntries = GetSpellTabInfo(profTabs[i])
				--print(name)
				--Update Icon Buttons
				for j = 1 , numEntries do
					local _,spellIndex = GetSpellBookItemInfo(offset + j, "spell")
					local spellName,_,texFile = GetSpellInfo(spellIndex)
					_G[UIObject[i]:GetName().."Icon"..j]:SetNormalTexture(texFile);
					_G[UIObject[i]:GetName().."Icon"..j].SpellID = spellIndex;
					_G[UIObject[i]:GetName().."Icon"..j].SpellOffset = offset + j;
					_G[UIObject[i]:GetName().."Icon"..j]:SetAttribute("type", "spell");
					_G[UIObject[i]:GetName().."Icon"..j]:SetAttribute("spell", spellName);
				end
				local coreName,fileID,curLv,maxLv,numIcons,_,skillLine,_,_,_,specName = GetProfessionInfo(profTabs[i])
				if numIcons == 1 then UIObject[i].Icon2:Hide() end
				--print(i..":"..SVPC.TIER[i])
				--print(GetProfessionInfo(profTabs[i]))
				--print("SkillLine:"..skillLine)
				--print("SLI:"..SLI[skillLine][SVPC.TIER[i]])
				-- Update Bar Information
				
				if i <= 2 then -- Primary skills
					if SVPC.TIER[i] == -1 then
						for j = 9, 1, -1 do
							if ({C_TradeSkillUI.GetTradeSkillLineInfoByID(SLI[skillLine][j])})[3] ~= 0 then 
								SVPC.TIER[i] = j
								UIObject[i].DropDown:SetItem(j)
								MiniHudProfessionSVPC = SVPC
								break;
							end
						end
					end
					local xName, xLv, xMax, xMod, xParentID = C_TradeSkillUI.GetTradeSkillLineInfoByID(SLI[skillLine][SVPC.TIER[i]])
					UIObject[i].Bar.Text:SetText(xName.." ["..xLv.."/"..xMax.."]");
					UIObject[i].Bar:SetMinMaxValues(0, xMax);
					UIObject[i].Bar:SetValue(xLv);
					
				else 	-- Secondary Skills
					if specName ~= nil then coreName = specName end
					UIObject[i].Bar.Text:SetText(coreName.." ["..curLv.."/"..maxLv.."]");
					UIObject[i].Bar:SetMinMaxValues(0, maxLv);
					UIObject[i].Bar:SetValue(curLv);
				end
				
			else
				UIObject[i].CheckButton:SetChecked(false)
				UIObject[i]:SetAlpha(0.25);
				UIObject[i].Bar.Text:SetText("Not Learned");
				UIObject[i].Bar:SetMinMaxValues(0, 1);
				UIObject[i].Bar:SetValue(1);
				UIObject[i].Icon1:SetNormalTexture(134400);
				UIObject[i].Icon1.SpellID = 0;
				UIObject[i].Icon1.SpellOffset = 0;
				UIObject[i].Icon1:Show();
				UIObject[i].Icon2:SetNormalTexture(134400);
				UIObject[i].Icon2.SpellID = 0;
				UIObject[i].Icon2.SpellOffset = 0;
				UIObject[i].Icon2:Show();
				--SVPC.TRACKING[i] = false
			end;
			--SVPC.TRACKING[i] = UIObject[i].CheckButton:GetChecked()
		end;
	end
	MiniHudProfessionSVPC = SVPC;
end

--[TOGCF] Toggle configuration mode
function F.Toggle(p_isShown)
	if debugMode then print("MHP: Toggle Config") end;
	if MHProfession.Frame:GetChildren() == nil or (SVPC.LOCK and p_isShown) then return end;
	local shownCount = 0
	F.Update()
	for k,v in ipairs({MHProfession.Frame:GetChildren()}) do
		SVPC.TRACKING[k]=v.CheckButton:GetChecked() and v.Bar.Text:GetText() ~= "Not Learned"
		v.CheckButton:SetChecked(SVPC.TRACKING[k])
		v:SetAlpha((v.CheckButton:GetChecked() and 1) or 0.25);
		v.CheckButton:SetShown(p_isShown)											-- Checkbox Shown
		v.Bar:SetPoint("RIGHT", v, "RIGHT", (p_isShown and -30 or -9), 0)			-- Bar Width
		v:SetHeight((not v.CheckButton:GetChecked() and not p_isShown) and 7 or 30)	-- Adjust entry frame height, to adjust stack
		v:SetShown(v.CheckButton:GetChecked() or p_isShown)							-- Skill Entry shown
		if v:IsShown() then 														-- Count shown entries
			shownCount = shownCount + 1 
			if k <= 2 then UIObject[k].DropDown:Show() end;
		else
			if k <= 2 then UIObject[k].DropDown:Hide() end;
		end;
	end
	MHProfession:SetHeight(16+(30*shownCount)- ((shownCount>1)and (7*(shownCount-1)) or 0));	-- Set Main Frame Height
	if MHProfession:GetHeight() <23 then 
		MHProfession:SetHeight(23) 																-- Clamp min height
		XPAC.Frame:Hide()
	else
		XPAC.Frame:Show()
	end
	
end

function F.GetCfgLocked()
	return SVPC.Lock
end

function F.Track(id, isTracked)
	SVPC.TRACKING[id]=isTracked
	MiniHudProfessionSVPC = SVPC;
end

function F.MultiCmdParse(msg)
	--handle empty msg
	if (msg == "") then
		return "";
	end
	local pos, size, main;
	local sub, find, len = string.sub, string.find, string.len;
	pos = find(msg, " ");
	if (pos == nil) then
		return msg; --handle single param commands
	end
	main = sub(msg, 0, pos - 1);
	size = len(msg);
	msg = sub(msg, pos + 1, size);
	local i = 0;
	local param = {};
	while ((msg ~= "") and (msg ~= " ") and (i < 30)) do
		pos = find(msg, " ");
		if (pos == nil) then
			param[i] = msg;
			break;
		else
			param[i] = sub(msg, 0, pos - 1);
			msg = sub(msg, pos + 1, size);
		end
		i = i + 1;
	end;
	return main, param;
end

function string.right(sourceString, rightLength)
	if rightLength > string.len(sourceString) then return end;
	return string.sub(sourceString, string.len(sourceString)-rightLength+1,string.len(sourceString))
end

function SlashCmdList.MiniHudProfession(msg)
	local param = {};
	msg, param = F.MultiCmdParse(msg);
	local later = F.Tag(Red.."This Command Will Be Active Later");
	if (msg == 'hide') then
		print(F.Tag("Hiding."));
		MHProfession:Hide();
		--ProfessionHUDPC.PH_VISIBLE = 0;
	elseif (msg == 'show') then
		--ProfessionHUDPC.PH_VISIBLE = 1;
		print(F.Tag("Showing."));
		MHProfession:Show();
	elseif (msg == "clear" or msg == "reset") then
		print(F.Tag("Clearing saved variables."));
		MiniHudProfessionSVPC = CopyTable(defaults);
		SVPC = CopyTable(defaults);
		F.Update();
	elseif (msg == 'lock') then
		SVPC.LOCK = not SVPC.LOCK
		print(F.Tag(((SVPC.LOCK and "L") or "Unl").."ocking configuration hover."));
		F.Toggle(SVPC.LOCK)
	elseif (msg == "refresh" or msg == "rf") then
		print(F.Tag("Updating"))
		F.Update()
	elseif (msg == 'test') then
		print(F.Tag("TEST"));
		XPAC:SetShown(not XPAC:IsShown())
	else
		print(F.Tag("Help"));
		print(Green.."/mhp "..Cyan.."[arg]");
		-- print(Green.."/ProfessionHUD "..Cyan.."[arg]");
		print(Yellow.."Args:");
		-- print(Cyan.." [g | guide] (Show An Explanation Of Features)");
		print(Green.." [help"..White.." or "..Cyan.. "[no arg]"..Green.."]".."|r|r (Show This Menu)");
		-- print(Green.." [config"..White.." or "..Cyan.. "cf]".."|r (Toggle Config Mode)");
		print(Green.." [refresh | rf]".."|r (Refresh Frame)");
		-- print(Green.." [mode | toggle] ".."|r(Notation Mode Toggle)");
		print(Green.." [hide | show] ".."|r(Hide/Show Frame)");
		print(Green.." [lock] ".."|r(Lock/Unlock Frame)");
		-- print(Green.." [link | plain] ".."|r(Show New Skills As Links/Plain Text)");
		-- print(Green.." [track | untrack] #".."|r(Tracks/Untracks the #th bar Of The 6)");
		-- print(Green.." [track inc] ".."|r(Tracks Only Incomplete Skills)");
		print(Green.." [clear | reset] ".."|r(Resets Saved Variables)");
		-- print(Green.." [pri | prime | primary] "..White.."(Show Primary Skills Only)");
		-- print(Green.." [sec | secondary] "..White.."(Show Secondary Skills Only)");
		-- print(Green.." [all] "..White.."(Show All Skills)");
		-- print(Green.." [xdir up | down] "..White.."(Sets Frame Expansion Direction)");
		-- print(Red.."[NI]"..Green.." = Not Implemented.");
		print(Green.."End Of Commands");
	end
	MiniHudProfessionSVPC = SVPC;
end

function RToGGradient(p_Percentage)
	-- p_Percentage = 0 to 100 -- 0 = Red; 50 = Yellow; 100 = Green
	if p_Percentage > 100 or p_Percentage < 0 then return nil end; -- Error handling
	return format("%2x%2x",floor(((p_Percentage < 50 and 100) or 2*(100-p_Percentage))* 2.55),floor(((p_Percentage > 50 and 100) or 2*p_Percentage)*2.55)) -- Condensed everything to one line;
end

_G[ADDONNAME] = F -- put our functions in the global environment under our addon name so we can access them from the .xml as ProfessionHUD.FunctionName